



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQLSERVER2008新增的审核/审计功能</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQLSERVER2008新增的审核/审计功能</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 21:41:46 </span>
						</div>
										<div class="post-content">
											
		<h1>SQLSERVER2008新增的审核/审计功能</h1>
<p>很多时候我们都需要对数据库或者数据库服务器实例进行审核/审计</p>
<p>例如对失败的登录次数进行审计，某个数据库上的DDL语句进行审计，某个数据库表里面的delete语句进行审计</p>
<p>事实上，我们这些审计的需求基本上都是为了一个目的：<strong>防黑客防入侵者防自家人</strong></p>
<p>上面的这些审计需求无非就是看一下有哪些人试图<strong>入侵数据库服务器</strong>，入侵了之后是否有<strong>drop表</strong>，是否有<strong>delete数据</strong></p>
<p>在SQLSERVER2008及以前版本可以选择的方案有</p>
<p>1、<a href="http://www.cnblogs.com/gaizai/p/3363220.html?ADUIN=1815357042&amp;ADSESSION=1387155615&amp;ADTAG=CLIENT.QQ.5275_.0&amp;ADPUBNO=26274" rel="external nofollow noreferrer">服务器级别DDL触发器</a>和数据库级别的DDL触发器（SQL2005及以上版本） 以及DML触发器</p>
<p>2、自己手工从事务日志里读取操作记录，权威的书都会说事务日志不是审核工具，一般大型数据库都会设置为简单模式，事务日志截断</p>
<p>3、依靠SQLSERVER ERRORLOG来检查登录审核，导致SQLSERVER ERRORLOG login相关的<strong>日志泛滥</strong> 导致SQL排错造成困难</p>
<p>4、事件通知：<a href="http://www.cnblogs.com/gaizai/p/3473553.html" rel="external nofollow noreferrer">http://www.cnblogs.com/gaizai/p/3473553.html</a><br />5、更改跟踪：<a href="http://www.cnblogs.com/gaizai/p/3482579.html" rel="external nofollow noreferrer">http://www.cnblogs.com/gaizai/p/3482579.html</a><br />6、变更数据捕获（CDC）：<a href="http://www.cnblogs.com/gaizai/p/3479731.html" rel="external nofollow noreferrer">http://www.cnblogs.com/gaizai/p/3479731.html</a></p>
<p>我们一般都会把C2 审核跟踪和登录审核里面只限成功的登录，以防止SQL ERRORLOG日志泛滥，因为服务器是很久才重启一次的，如果不做修改很容易造成磁盘爆满</p>
<div>
<pre class="prettyprint linenums">--禁用C2 审核跟踪和只限成功的登录<br />
EXEC sys.sp_configure N'c2 audit mode', N''<br />
GO<br />
RECONFIGURE WITH OVERRIDE<br />
GO

USE [master]<br />
GO<br />
EXEC xp_instance_regwrite N'HKEY_LOCAL_MACHINE', N'Software\Microsoft\MSSQLServer\MSSQLServer', N'AuditLevel', REG_DWORD, 1<br />
GO</pre>
</div>
<hr />
<p><strong>SQLSERVER2008新增的审核功能</strong></p>
<p>在sqlserver2008新增了审核功能，可以对服务器级别和数据库级别的操作进行审核/审计，事实上，事件通知、更改跟踪、变更数据捕获（CDC）</p>
<p>都不是用来做审计的，只是某些人乱用这些功能，也正因为乱用这些功能导致踩坑</p>
<p><a href="http://msdn.microsoft.com/zh-cn/library/ms186376.aspx" rel="external nofollow noreferrer">事件通知</a>：性能跟踪</p>
<p>更改跟踪：用Sync Services来构建偶尔连接的系统</p>
<p>变更数据捕获（CDC）：数据仓库的ETL 中的数据抽取（背后使用logreader）</p>
<p>而审核是SQLSERVER专门针对数据库安全的进行的审核，记住，他是<strong>专门和专业的</strong>！</p>
<p>我们看一下审核的使用方法</p>
<p><strong>审核对象</strong></p>
<p>步骤一：创建审核对象，审核对象是跟保存路径关联的，所以如果你需要把审核操作日志保存到不同的路径就需要创建不同的审核对象</p>
<p>我们把审核操作日志保存在文件系统里，在创建之前我们还要在相关路径先创建好保存的文件夹，我们在D盘先创建sqlaudits文件夹，然后执行下面语句</p>
<div>
<pre class="prettyprint linenums">--创建审核对象之前需要切换到master数据库<br />
USE [master]<br />
GO<br />
CREATE SERVER AUDIT MyFileAudit TO FILE(FILEPATH='D:\sqlaudits') --这里指定文件夹不能指定文件，生成文件都会保存在这个文件夹<br />
GO</pre>
</div>
<p>实际上，我们在创建审核对象的同时可以指定审核选项，下面是相关脚本</p>
<p>把日志放在磁盘的好处是可以使用新增的TVF:sys.[fn_get_audit_file] 来过滤和排序审核数据，如果把审核数据保存在Windows 事件日志里查询起来非常麻烦</p>
<div>
<pre class="prettyprint linenums">USE [master]<br />
GO<br />
CREATE SERVER AUDIT MyFileAudit TO FILE(<br />
FILEPATH='D:\sqlaudits',<br />
MAXSIZE=4GB,<br />
MAX_ROLLOVER_FILES=6)<br />
WITH (<br />
ON_FAILURE=CONTINUE,<br />
QUEUE_DELAY=1000);

ALTER SERVER AUDIT MyFileAudit WITH(STATE =ON)</pre>
</div>
<p>MAXSIZE：指明每个审核日志文件的最大大小是4GB</p>
<p>MAX_ROLLOVER_FILES：指明滚动文件数目，类似于SQL ERRORLOG，达到多少个文件之后删除前面的历史文件，这里是6个文件</p>
<p>ON_FAILURE：指明当审核数据发生错误时的操作，这里是继续进行审核，如果指定shutdown，那么将会shutdown整个实例</p>
<p>queue_delay：指明审核数据写入的延迟时间，这里是1秒，最小值也是1秒，如果指定0表示是实时写入，当然性能也有一些影响</p>
<p>STATE：指明启动审核功能，STATE这个选项不能跟其他选项共用，所以只能单独一句</p>
<p>在修改审核选项的时候，需要先禁用审核，再开启审核</p>
<div>
<pre class="prettyprint linenums">ALTER SERVER AUDIT MyFileAudit WITH(STATE =OFF)<br />
ALTER SERVER AUDIT MyFileAudit WITH(QUEUE_DELAY =1000)<br />
ALTER SERVER AUDIT MyFileAudit WITH(STATE =ON)</pre>
</div>
<hr />
<p><strong>审核规范</strong></p>
<p>在SQLSERVER审核里面有审核规范的概念，一个审核对象只能绑定一个审核规范，而一个审核规范可以绑定到多个审核对象</p>
<p>我们来看一下脚本</p>
<div>
<pre class="prettyprint linenums">CREATE SERVER AUDIT SPECIFICATION CaptureLoginsToFile<br />
FOR SERVER AUDIT MyFileAudit<br />
ADD (failed_login_group),<br />
ADD (successful_login_group)<br />
WITH (STATE=ON)<br />
GO

CREATE SERVER AUDIT MyAppAudit TO APPLICATION_LOG<br />
GO<br />
ALTER SERVER AUDIT MyAppAudit WITH(STATE =ON)<br />
ALTER SERVER AUDIT SPECIFICATION CaptureLoginsToFile WITH (STATE=OFF)<br />
GO<br />
ALTER SERVER AUDIT SPECIFICATION CaptureLoginsToFile<br />
FOR SERVER AUDIT MyAppAudit<br />
ADD (failed_login_group),<br />
ADD (successful_login_group)<br />
WITH (STATE=ON)<br />
GO</pre>
</div>
<p>我们创建一个服务器级别的审核规范CaptureLoginsToFile，然后再创建多一个审核对象MyAppAudit ，这个审核对象会把审核日志保存到Windows事件日志的应用程序日志里</p>
<p>我们禁用审核规范CaptureLoginsToFile，修改审核规范CaptureLoginsToFile属于审核对象MyAppAudit ，修改成功</p>
<p>而如果要把多个审核规范绑定到同一个审核对象则会报错</p>
<div>
<pre class="prettyprint linenums">CREATE SERVER AUDIT SPECIFICATION CaptureLoginsToFileA<br />
FOR SERVER AUDIT MyFileAudit<br />
ADD (failed_login_group),<br />
ADD (successful_login_group)<br />
WITH (STATE=ON)<br />
GO

CREATE SERVER AUDIT SPECIFICATION CaptureLoginsToFileB<br />
FOR SERVER AUDIT MyFileAudit<br />
ADD (failed_login_group),<br />
ADD (successful_login_group)<br />
WITH (STATE=ON)<br />
GO

--消息 33230，级别 16，状态 1，第 86 行<br />
--审核 'MyFileAudit' 的审核规范已经存在。</pre>
</div>
<p>这里要说一下 ：审核对象和审核规范的修改 ，无论是审核对象还是审核规范，在修改他们的相关参数之前，他必须要先禁用，后修改，再启用</p>
<div>
<pre class="prettyprint linenums">--禁用审核对象<br />
ALTER SERVER AUDIT MyFileAudit WITH(STATE =OFF)<br />
--禁用服务器级审核规范<br />
ALTER SERVER AUDIT SPECIFICATION CaptureLoginsToFile WITH (STATE=OFF)<br />
GO<br />
--禁用数据库级审核规范<br />
ALTER DATABASE AUDIT SPECIFICATION CaptureDBLoginsToFile WITH (STATE=OFF)<br />
GO

--相关修改选项操作

--启用审核对象<br />
ALTER SERVER AUDIT MyFileAudit WITH(STATE =ON)<br />
--启用服务器级审核规范<br />
ALTER SERVER AUDIT SPECIFICATION CaptureLoginsToFile WITH (STATE=ON)<br />
GO<br />
--启用数据库级审核规范<br />
ALTER DATABASE AUDIT SPECIFICATION CaptureDBLoginsToFile WITH (STATE=ON)<br />
GO</pre>
</div>
<p><strong>审核服务器级别事件</strong></p>
<p>审核服务级别事件，我们一般用得最多的就是审核登录失败的事件，下面的脚本就是审核登录成功事件和登录失败事件</p>
<div>
<pre class="prettyprint linenums">CREATE SERVER AUDIT SPECIFICATION CaptureLoginsToFile<br />
FOR SERVER AUDIT MyFileAudit<br />
ADD (failed_login_group),<br />
ADD (successful_login_group)<br />
WITH (STATE=ON)<br />
GO</pre>
</div>
<p>修改审核规范</p>
<div>
<pre class="prettyprint linenums">--跟审核对象一样，更改审核规范时必须将其禁用<br />
ALTER SERVER AUDIT SPECIFICATION CaptureLoginsToFile WITH (STATE =OFF)<br />
ALTER SERVER AUDIT SPECIFICATION CaptureLoginsToFile<br />
ADD (login_change_password_gourp),<br />
DROP (successful_login_group)<br />
ALTER SERVER AUDIT SPECIFICATION CaptureLoginsToFile WITH (STATE =ON)<br />
GO</pre>
</div>
<p><strong>审核操作组</strong></p>
<p>每个审核操作组对应一种操作，在SQLSERVER2008里一共有35个操作组，包括备份和还原操作，数据库所有权的更改，从服务器和数据库角色中添加或删除登录用户</p>
<p>添加审核操作组的只需在审核规范里使用ADD，下面语句添加了登录用户修改密码操作的操作组</p>
<div>
<pre class="prettyprint linenums">ADD (login_change_password_gourp)</pre>
</div>
<p>这里说一下服务器审核的内部实际上使用的是SQL2008新增的扩展事件里面的其中一个package：SecAudit package，当然他内部也是使用扩展事件来收集服务器信息</p>
<p><strong>审核数据库级别事件</strong></p>
<p>数据库审核规范存在于他们的数据库中，不能审核tempdb中的数据库操作</p>
<p>CREATE DATABASE AUDIT SPECIFICATION和ALTER DATABASE AUDIT SPECIFICATION</p>
<p>工作方式跟服务器审核规范一样</p>
<p>在SQLSERVER2008里一共有15个数据库级别的操作组<br />7个数据库级别的审核操作是：select ,insert,update,delete,execute,receive,references</p>
<p>相关脚本如下：</p>
<div>
<pre class="prettyprint linenums">--创建审核对象<br />
USE [master]<br />
GO<br />
CREATE SERVER AUDIT MyDBFileAudit TO FILE(FILEPATH='D:\sqldbaudits')<br />
GO<br />
ALTER  SERVER AUDIT  MyDBFileAudit WITH (STATE=ON)<br />
GO<br />
--创建数据库级别审核规范<br />
USE [sss]<br />
GO<br />
CREATE DATABASE AUDIT SPECIFICATION CaptureDBActionToEventLog<br />
FOR SERVER AUDIT MyDBFileAudit<br />
ADD (database_object_change_group),<br />
ADD (SELECT ,INSERT,UPDATE,DELETE ON schema::dbo   BY PUBLIC)<br />
WITH (STATE =ON)</pre>
</div>
<p>我们先在D盘创建sqldbaudits文件夹</p>
<p>第一个操作组对数据库中所有对象的DDL语句create，alter，drop等进行记录<br />第二个语句监视由任何public用户（也就是所有用户）对dbo架构的任何对象所做的DML操作</p>
<p>创建完毕之后可以在SSMS里看到相关的审核</p>
<p>数据库审核规范</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041753514084344.jpg" /></p>
<p>服务器审核规范和审核对象</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041754147528812.jpg" /></p>
<hr />
<p><strong>查看审核事件</strong></p>
<p>被记录到文件系统的审核文件不是存储在可以利用记事本打开的文本文件中，而是采用二进制文件的方式</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041907185331310.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041759060176397.jpg" /></p>
<p>这里说一个，当磁盘空间不足的时候是可以直接删除这些SQLAUDIT文件</p>
<p>如果使用DDL触发器的方法：<a href="http://www.cnblogs.com/gaizai/p/3363220.html?ADUIN=1815357042&amp;ADSESSION=1387155615&amp;ADTAG=CLIENT.QQ.5275_.0&amp;ADPUBNO=26274" rel="external nofollow noreferrer">http://www.cnblogs.com/gaizai/p/3363220.html?ADUIN=xxx2&amp;ADSESSION=1387155615&amp;ADTAG=CLIENT.QQ.5275_.0&amp;ADPUBNO=26274</a></p>
<p>一般都会在数据库里头创建一张表来保存审计数据，但是当表数据量达到很多的时候，DBA也需要去维护这张表</p>
<p>工作量又增加了，可能你会说，我需要审计的项目不多，所以审计的数据也不会太多，但对于某些大公司来说</p>
<p>他们要审计的数据是非常多的，有些需要归档，而有些不需要归档</p>
<p>对于不需要归档审计数据的情况，我比较喜欢这种方式，当磁盘容量不够的时候把最老的那个审计文件删除掉</p>
<p>当然，你可以把整个sqlaudits文件夹或某个sqlaudit文件进行备份，放到备份磁盘上，然后删除一些较老的sqlaudit文件</p>
<p>备份了之后以后就有机会对之前的审计数据进行翻查，都比较灵活</p>
<p>我们有两种方法查看审核日志</p>
<p>方法一：对象资源管理器-》安全性-》审核-》选中某个审核对象-》右键-》查看审核日志</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041800498306547.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041913406895726.jpg" /></p>
<p>审核项目包括有：日期、时间戳记、服务器实例名称、操作ID、类类型、序列号、成功或失败、列权限、数据库主体ID、服务器主体名称、</p>
<p>服务器主体SID、被执行的（或尝试）的实际语句等等</p>
<p>方法二：使用新的表值函数sys.[fn_get_audit_file]()</p>
<p>此函数接受一个或多个审核文件的参数（使用通配符模式匹配）</p>
<p>并利用另外两个附加参数可以指定要处理的起始文件，以及开始读取审核的已知偏移位置</p>
<p>这两个参数都是可选的，但依然必须使用关键字default指定，此函数随后从文件中读取二进制数据，并将格式化这些审核项目</p>
<p>服务器级别审核</p>
<p>根据最近时间的那个sqlaudit文件，查询这个文件里面的信息</p>
<div>
<pre class="prettyprint linenums">SELECT  [event_time] AS '触发审核的日期和时间' ,<br />
        sequence_number AS '单个审核记录中的记录顺序' ,<br />
        action_id AS '操作的 ID' ,<br />
        succeeded AS '触发事件的操作是否成功' ,<br />
        permission_bitmask AS '权限掩码' ,<br />
        is_column_permission AS '是否为列级别权限' ,<br />
        session_id AS '发生该事件的会话的 ID' ,<br />
        server_principal_id AS '执行操作的登录上下文 ID' ,<br />
        database_principal_id AS '执行操作的数据库用户上下文 ID' ,<br />
        target_server_principal_id AS '执行 GRANT/DENY/REVOKE 操作的服务器主体' ,<br />
        target_database_principal_id AS '执行 GRANT/DENY/REVOKE 操作的数据库主体' ,<br />
        object_id AS '发生审核的实体的 ID(服务器对象，DB,数据库对象，架构对象)' ,<br />
        class_type AS '可审核实体的类型' ,<br />
        session_server_principal_name AS '会话的服务器主体' ,<br />
        server_principal_name AS '当前登录名' ,<br />
        server_principal_sid AS '当前登录名 SID' ,<br />
        database_principal_name AS '当前用户' ,<br />
        target_server_principal_name AS '操作的目标登录名' ,<br />
        target_server_principal_sid AS '目标登录名的 SID' ,<br />
        target_database_principal_name AS '操作的目标用户' ,<br />
        server_instance_name AS '审核的服务器实例的名称' ,<br />
        database_name AS '发生此操作的数据库上下文' ,<br />
        schema_name AS '此操作的架构上下文' ,<br />
        object_name AS '审核的实体的名称' ,<br />
        statement AS 'TSQL 语句（如果存在）' ,<br />
        additional_information AS '单个事件的唯一信息，以 XML 的形式返回' ,<br />
        file_name AS '记录来源的审核日志文件的路径和名称' ,<br />
        audit_file_offset AS '包含审核记录的文件中的缓冲区偏移量' ,<br />
        user_defined_event_id AS '作为 sp_audit_write 参数传递的用户定义事件 ID' ,<br />
        user_defined_information AS '于记录用户想要通过使用 sp_audit_write 存储过程记录在审核日志中的任何附加信息'<br />
FROM    sys.[fn_get_audit_file]('D:\sqlaudits\MyFileAudit_F0BCDC6F-0A89-459D-B345-9DDEB036CC39_0_130595725124220000.sqlaudit',<br />
                                DEFAULT, DEFAULT)<br />
WHERE   [event_time] BETWEEN '2014-11-04 11:02:00'<br />
                     AND     '2014-11-04 11:18:00' </pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041928087209037.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041943598303801.jpg" /></p>
<p>数据库级别审核</p>
<p>先执行下面脚本查询一些数据</p>
<div>
<pre class="prettyprint linenums">USE [sss]<br />
GO<br />
SELECT * FROM [dbo].[nums]</pre>
</div>
<div>
<pre class="prettyprint linenums">SELECT  [event_time] AS '触发审核的日期和时间' ,<br />
        sequence_number AS '单个审核记录中的记录顺序' ,<br />
        action_id AS '操作的 ID' ,<br />
        succeeded AS '触发事件的操作是否成功' ,<br />
        permission_bitmask AS '权限掩码' ,<br />
        is_column_permission AS '是否为列级别权限' ,<br />
        session_id AS '发生该事件的会话的 ID' ,<br />
        server_principal_id AS '执行操作的登录上下文 ID' ,<br />
        database_principal_id AS '执行操作的数据库用户上下文 ID' ,<br />
        target_server_principal_id AS '执行 GRANT/DENY/REVOKE 操作的服务器主体' ,<br />
        target_database_principal_id AS '执行 GRANT/DENY/REVOKE 操作的数据库主体' ,<br />
        object_id AS '发生审核的实体的 ID(服务器对象，DB,数据库对象，架构对象)' ,<br />
        class_type AS '可审核实体的类型' ,<br />
        session_server_principal_name AS '会话的服务器主体' ,<br />
        server_principal_name AS '当前登录名' ,<br />
        server_principal_sid AS '当前登录名 SID' ,<br />
        database_principal_name AS '当前用户' ,<br />
        target_server_principal_name AS '操作的目标登录名' ,<br />
        target_server_principal_sid AS '目标登录名的 SID' ,<br />
        target_database_principal_name AS '操作的目标用户' ,<br />
        server_instance_name AS '审核的服务器实例的名称' ,<br />
        database_name AS '发生此操作的数据库上下文' ,<br />
        schema_name AS '此操作的架构上下文' ,<br />
        object_name AS '审核的实体的名称' ,<br />
        statement AS 'TSQL 语句（如果存在）' ,<br />
        additional_information AS '单个事件的唯一信息，以 XML 的形式返回' ,<br />
        file_name AS '记录来源的审核日志文件的路径和名称' ,<br />
        audit_file_offset AS '包含审核记录的文件中的缓冲区偏移量' ,<br />
        user_defined_event_id AS '作为 sp_audit_write 参数传递的用户定义事件 ID' ,<br />
        user_defined_information AS '于记录用户想要通过使用 sp_audit_write 存储过程记录在审核日志中的任何附加信息'<br />
FROM    sys.[fn_get_audit_file]('D:\sqldbaudits\MyDBFileAudit_698BA060-CC40-4A3C-B19D-12B370712404_0_130595753193920000.sqlaudit',<br />
                                DEFAULT, DEFAULT)</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041953256745866.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/041953339869459.jpg" /></p>
<p>将审核日志保存到文件系统的好处就是可以使用TVP里通过where 和order by对审核数据进行筛选和排序</p>
<p>和审核相关的视图</p>
<div>
<pre class="prettyprint linenums">--查询审核相关视图<br />
SELECT * FROM sys.[server_file_audits]<br />
SELECT * FROM sys.[server_audit_specifications]<br />
SELECT * FROM sys.[server_audit_specification_details]<br />
SELECT * FROM sys.[database_audit_specifications]<br />
SELECT * FROM sys.[database_audit_specification_details]<br />
SELECT * FROM sys.[dm_server_audit_status]<br />
SELECT * FROM sys.[dm_audit_actions]<br />
SELECT * FROM sys.[dm_audit_class_type_map]</pre>
</div>
<p>删除相关对象</p>
<div>
<pre class="prettyprint linenums">--删除顺序<br />
--删除数据库审核规范<br />
USE [sss]<br />
GO<br />
ALTER DATABASE AUDIT SPECIFICATION [CaptureDBActionToEventLog] WITH (STATE=OFF)<br />
GO<br />
DROP DATABASE AUDIT SPECIFICATION [CaptureDBActionToEventLog]<br />
GO

--删除服务器审核规范<br />
USE [master]<br />
GO<br />
ALTER SERVER  AUDIT SPECIFICATION [CaptureLoginsToFile] WITH (STATE=OFF)<br />
GO<br />
DROP SERVER AUDIT SPECIFICATION [CaptureLoginsToFile]<br />
GO

--删除审核对象<br />
ALTER SERVER AUDIT [MyFileAudit] WITH (STATE=OFF)<br />
GO<br />
ALTER SERVER AUDIT [MyAppAudit] WITH (STATE=OFF)<br />
GO<br />
ALTER SERVER AUDIT [MyEventLogAudit] WITH (STATE=OFF)<br />
GO<br />
DROP SERVER AUDIT [MyAppAudit]<br />
GO<br />
DROP SERVER AUDIT [MyFileAudit]<br />
GO<br />
DROP SERVER AUDIT [MyEventLogAudit]<br />
GO</pre>
</div>
<p>要查看是否打开了审核引擎使用下面SQL语句</p>
<p>&ldquo;XE engine initialized已经初始化&rdquo;表示审核引擎已经打开，扩展事件可以捕获审核事件</p>
<div>
<pre class="prettyprint linenums">SELECT * FROM sys.[dm_os_ring_buffers] WHERE [ring_buffer_type]='RING_BUFFER_XE_LOG'

&lt;Record id = "0" type ="RING_BUFFER_XE_LOG" time ="106735"&gt;<br />
&lt;XE_LogRecord message="XE engine initialized"&gt;&lt;/XE_LogRecord&gt;&lt;/Record&gt;</pre>
</div>
<hr />
<p><strong>总结</strong></p>
<p>本文概括介绍了SQLSERVER2008新增的审核功能，在SQLSERVER相关论坛里面&ldquo;审核&rdquo;这个话题是大家问得比较多的</p>
<p>希望通过这篇文章，能让大家认识新增的审核功能，在生产环境里面遇到问题也可以互相交流</p>
<p>而审核功能最大的好处是：<strong>你使用自建审计表来保存审计数据，如果聪明的黑客攻破你的数据库实例，他自然可以把你的那个审计表</strong></p>
<p><strong>drop掉，你同样查不出黑客的任何蛛丝马迹，而审核不同，他把审核数据放在SQLSERVER外面，除非你们公司的SA和DBA的安全意识</strong></p>
<p><strong>很弱，黑客有机会把磁盘文件删除掉，否则依然有可能查出黑客的蛛丝马迹进行预防！！</strong></p>
<p>msdn相关文章：</p>
<p><a href="http://msdn.microsoft.com/en-us/library/cc280448.aspx" rel="external nofollow noreferrer">CREATE SERVER AUDIT (Transact-SQL)</a></p>
<p><a href="http://msdn.microsoft.com/en-us/library/cc280663.aspx" rel="external nofollow noreferrer">SQL Server Audit Action Groups and Actions</a></p>
<p><a href="http://technet.microsoft.com/zh-cn/library/cc280765.aspx" rel="external nofollow noreferrer">sys.fn_get_audit_file (Transact-SQL)</a></p>
<p><strong>如有不对的地方，欢迎大家拍砖o(&cap;_&cap;)o&nbsp;</strong></p>
<p><strong>补充：搬迁数据库后，数据库审核规范是不会删除的，你可以在新的数据库实例上再创建审核对象并把审核对象绑定到原来的数据库审核规范</strong></p>
<div>
<pre class="prettyprint linenums">--附加数据库，模拟搬迁数据库<br />
USE [master]<br />
GO<br />
CREATE DATABASE [MacFilter] ON<br />
( FILENAME = N'E:\DataBase\MacFilter.mdf' ),<br />
( FILENAME = N'E:\DataBase\MacFilter_log.ldf' )<br />
 FOR ATTACH<br />
GO

--在新实例上重新创建审核对象<br />
CREATE SERVER AUDIT MyFileAudit TO FILE(<br />
FILEPATH='E:\sqlaudits',<br />
MAXSIZE=4GB,<br />
MAX_ROLLOVER_FILES=6)<br />
WITH (<br />
ON_FAILURE=CONTINUE,<br />
QUEUE_DELAY=1000);

ALTER SERVER AUDIT MyFileAudit WITH(STATE =ON)

--修改原来的数据库级别审核规范<br />
USE [MacFilter]<br />
GO<br />
ALTER DATABASE AUDIT SPECIFICATION CaptureDBActionToEventLog WITH (STATE =OFF)<br />
GO<br />
--重新绑定<br />
ALTER DATABASE AUDIT SPECIFICATION CaptureDBActionToEventLog<br />
FOR SERVER AUDIT MyFileAudit<br />
WITH (STATE =ON)

--更新测试<br />
UPDATE [Mac_Table] SET [MAC]=22 WHERE [PcName]='android_3eb52207eb8b89ee'

--查询审核数据<br />
SELECT  [event_time] AS '触发审核的日期和时间' ,<br />
        sequence_number AS '单个审核记录中的记录顺序' ,<br />
        action_id AS '操作的 ID' ,<br />
        succeeded AS '触发事件的操作是否成功' ,<br />
        permission_bitmask AS '权限掩码' ,<br />
        is_column_permission AS '是否为列级别权限' ,<br />
        session_id AS '发生该事件的会话的 ID' ,<br />
        server_principal_id AS '执行操作的登录上下文 ID' ,<br />
        database_principal_id AS '执行操作的数据库用户上下文 ID' ,<br />
        target_server_principal_id AS '执行 GRANT/DENY/REVOKE 操作的服务器主体' ,<br />
        target_database_principal_id AS '执行 GRANT/DENY/REVOKE 操作的数据库主体' ,<br />
        object_id AS '发生审核的实体的 ID(服务器对象，DB,数据库对象，架构对象)' ,<br />
        class_type AS '可审核实体的类型' ,<br />
        session_server_principal_name AS '会话的服务器主体' ,<br />
        server_principal_name AS '当前登录名' ,<br />
        server_principal_sid AS '当前登录名 SID' ,<br />
        database_principal_name AS '当前用户' ,<br />
        target_server_principal_name AS '操作的目标登录名' ,<br />
        target_server_principal_sid AS '目标登录名的 SID' ,<br />
        target_database_principal_name AS '操作的目标用户' ,<br />
        server_instance_name AS '审核的服务器实例的名称' ,<br />
        database_name AS '发生此操作的数据库上下文' ,<br />
        schema_name AS '此操作的架构上下文' ,<br />
        object_name AS '审核的实体的名称' ,<br />
        statement AS 'TSQL 语句（如果存在）' ,<br />
        additional_information AS '单个事件的唯一信息，以 XML 的形式返回' ,<br />
        file_name AS '记录来源的审核日志文件的路径和名称' ,<br />
        audit_file_offset AS '包含审核记录的文件中的缓冲区偏移量'<br />
FROM    sys.[fn_get_audit_file]('e:\sqlaudits\MyFileAudit_149774D4-C5D9-4700-9FA1-AF0E13CED504_0_130595854334250000.sqlaudit',<br />
                                DEFAULT, DEFAULT)</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/257159/201411/042248029554231.jpg" /></p>
<p>脚本更新</p>
<div>
<pre class="prettyprint linenums">--查看审核结果

----查询服务器审核事件<br />
SELECT  fgaf.[event_time] AS '触发审核的日期和时间' ,<br />
        fgaf.sequence_number AS '单个审核记录中的记录顺序' ,<br />
        fgaf.action_id AS '操作的 ID' ,<br />
        fgaf.succeeded AS '触发事件的操作是否成功' ,<br />
        fgaf.permission_bitmask AS '权限掩码' ,<br />
        fgaf.is_column_permission AS '是否为列级别权限' ,<br />
        fgaf.session_id AS '发生该事件的会话的 ID' ,<br />
        fgaf.server_principal_id AS '执行操作的登录上下文 ID' ,<br />
        fgaf.database_principal_id AS '执行操作的数据库用户上下文 ID' ,<br />
        fgaf.target_server_principal_id AS '执行 GRANT/DENY/REVOKE 操作的服务器主体' ,<br />
        fgaf.target_database_principal_id AS '执行 GRANT/DENY/REVOKE 操作的数据库主体' ,<br />
        fgaf.object_id AS '发生审核的实体的 ID(服务器对象，DB,数据库对象，架构对象)' ,<br />
        fgaf.class_type AS '可审核实体的类型' ,<br />
        --[dactm].[class_type_desc] AS '可审核实体的类型描述' ,<br />
        fgaf.session_server_principal_name AS '会话的服务器主体' ,<br />
        fgaf.server_principal_name AS '当前登录名' ,<br />
        fgaf.server_principal_sid AS '当前登录名 SID' ,<br />
        fgaf.database_principal_name AS '当前用户' ,<br />
        fgaf.target_server_principal_name AS '操作的目标登录名' ,<br />
        fgaf.target_server_principal_sid AS '目标登录名的 SID' ,<br />
        fgaf.target_database_principal_name AS '操作的目标用户' ,<br />
        fgaf.server_instance_name AS '审核的服务器实例的名称' ,<br />
        fgaf.database_name AS '发生此操作的数据库上下文' ,<br />
        fgaf.schema_name AS '此操作的架构上下文' ,<br />
        fgaf.object_name AS '审核的实体的名称' ,<br />
        fgaf.statement AS 'TSQL 语句（如果存在）' ,<br />
        fgaf.additional_information AS '单个事件的唯一信息，以 XML 的形式返回' ,<br />
        fgaf.file_name AS '记录来源的审核日志文件的路径和名称' ,<br />
        fgaf.audit_file_offset AS '包含审核记录的文件中的缓冲区偏移量'<br />
FROM    sys.[fn_get_audit_file]('E:\DataBaseAudit\ServerAudit\ServerFileAudit_9E770D97-AD49-466A-8367-7885850200F8_0_130596271711880000.sqlaudit',<br />
                                DEFAULT, DEFAULT) AS fgaf<br />
        INNER JOIN sys.[dm_audit_class_type_map] AS dactm ON [dactm].[class_type] = [fgaf].[class_type]<br />
WHERE   fgaf.[event_time] BETWEEN '2014-11-04'<br />
                          AND     '2014-11-06'<br />
ORDER BY fgaf.[event_time] 

----查询某个数据库的审核事件<br />
SELECT  fgaf.[event_time] AS '触发审核的日期和时间' ,<br />
        fgaf.sequence_number AS '单个审核记录中的记录顺序' ,<br />
        fgaf.action_id AS '操作的 ID' ,<br />
        fgaf.succeeded AS '触发事件的操作是否成功' ,<br />
        fgaf.permission_bitmask AS '权限掩码' ,<br />
        fgaf.is_column_permission AS '是否为列级别权限' ,<br />
        fgaf.session_id AS '发生该事件的会话的 ID' ,<br />
        fgaf.server_principal_id AS '执行操作的登录上下文 ID' ,<br />
        fgaf.database_principal_id AS '执行操作的数据库用户上下文 ID' ,<br />
        fgaf.target_server_principal_id AS '执行 GRANT/DENY/REVOKE 操作的服务器主体' ,<br />
        fgaf.target_database_principal_id AS '执行 GRANT/DENY/REVOKE 操作的数据库主体' ,<br />
        fgaf.object_id AS '发生审核的实体的 ID(服务器对象，DB,数据库对象，架构对象)' ,<br />
        fgaf.class_type AS '可审核实体的类型' ,<br />
        [dactm].[class_type_desc] AS '可审核实体的类型描述' ,<br />
        fgaf.session_server_principal_name AS '会话的服务器主体' ,<br />
        fgaf.server_principal_name AS '当前登录名' ,<br />
        fgaf.server_principal_sid AS '当前登录名 SID' ,<br />
        fgaf.database_principal_name AS '当前用户' ,<br />
        fgaf.target_server_principal_name AS '操作的目标登录名' ,<br />
        fgaf.target_server_principal_sid AS '目标登录名的 SID' ,<br />
        fgaf.target_database_principal_name AS '操作的目标用户' ,<br />
        fgaf.server_instance_name AS '审核的服务器实例的名称' ,<br />
        fgaf.database_name AS '发生此操作的数据库上下文' ,<br />
        fgaf.schema_name AS '此操作的架构上下文' ,<br />
        fgaf.object_name AS '审核的实体的名称' ,<br />
        fgaf.statement AS 'TSQL 语句（如果存在）' ,<br />
        fgaf.additional_information AS '单个事件的唯一信息，以 XML 的形式返回' ,<br />
        fgaf.file_name AS '记录来源的审核日志文件的路径和名称' ,<br />
        fgaf.audit_file_offset AS '包含审核记录的文件中的缓冲区偏移量'<br />
FROM    sys.[fn_get_audit_file]('E:\DataBaseAudit\DBAudit_db\DBFileAudit_db%8O%89095_794BC4B9-4126-4CF7-BDD9-F24D8DA1CE70_0_130596271711960000.sqlaudit',<br />
                                DEFAULT, DEFAULT) AS fgaf<br />
        INNER JOIN sys.[dm_audit_class_type_map] AS dactm ON [dactm].[class_type] = [fgaf].[class_type]<br />
WHERE   fgaf.[event_time] BETWEEN '2014-11-04'<br />
                          AND     '2014-11-06'<br />
ORDER BY fgaf.[event_time] 

--服务器审核规范详细<br />
SELECT * FROM sys.[server_audit_specification_details]<br />
--数据库审核规范详细<br />
SELECT * FROM sys.[database_audit_specification_details]

SELECT * FROM sys.[dm_audit_actions] </pre>
</div>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kl0rqj.html">查看Job执行的历史记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8olmrp8.html">JavaScript数组与对象的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r2674q.html">【MVC】 js，css 压缩</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q74kkeq.html">POJ1201 Intervals（差分约束系统）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjepxk9.html">使用Oracle的存储过程批量插入数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdy6nl8.html">Bootstrap&lowbar;Javascript&lowbar;选项卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1zxox9.html">Swift Core Data 图片存储与读取Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1mk7n9.html">ASP&period;NET MVC 学习之路-6</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzxr7e8.html">Linux目录结构介绍-http&colon;&sol;&sol;yangrong&period;blog&period;51cto&period;com&sol;6945369&sol;1288072</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1j1vmq.html">Linux Shell 命令--rename</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgxj1m8.html">windows查看进程信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyp5gz9.html">makefile编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j14v7g9.html">关于Vue中的 render&colon; h &equals;&amp;gt&semi; h&lpar;App&rpar; 具体是什么含义？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pdgjjq.html">3层&plus;SVN学习笔记（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2461e8.html">python---权限管理和菜单生成</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o40vdxq.html">SQL Server 查询表的主键的两种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkz6jn8.html">java开发注解大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveg02o9.html">转载：vim的复制，删除，粘贴，块操作以及快速替换功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdv411q.html">Mysql--产品支持的平台</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0l0yzq.html">Python-Django框架学习笔记&mdash;&mdash;第二课：Django的搭建</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8z3mgdq.html">Microsoft Visual Stduio 2005 Ent安装报错解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jlkyeq.html">初学git（一）：创建本地&OpenCurlyDoubleQuote;仓库&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mkolrq.html">JavaScript Window 对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggn649.html">Regular Expression Matching leetcode</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oyxplq.html">transition-delay</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mko1oq.html">【如何快速的开发一个完整的iOS直播app】&lpar;原理篇&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q72mgx9.html">&lbrack;python&rsqb; os&period;path说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2gj3l8.html">putpixel</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1ykd4q.html">排序陷阱 List&period;Sort Linq&period;OrderBy</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlwjge8.html">MMS源码中异步处理简析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
